/*
         ORBIS 3.0

         FILEXFR.H

         Constantes para as rotinas de transferencia de arquivos

*/
#ifndef BYTE
#include "dosintrf.h"
#endif


typedef unsigned char BYTE;
typedef unsigned int  WORD;

typedef enum
   {
   DESCONHECIDO,
   XMODEM_CHKSUM,
   XMODEM_CRC,
   YMODEM_CHKSUM,
   YMODEM_CRC,
   } PROTOCOLO;

typedef enum
   {
   ENVIANDO_CABEC      = 0,
   AGUARDANDO_INICIO,
   ENVIANDO_BLOCO,
   AGUARDANDO_RESPOSTA,
   TERMINANDO,
   CANCELANDO,
   AGUARDANDO_BLOCO,
   RECEBENDO_BLOCO,
   AGUARDANDO_CABEC,
   RECEBENDO_CABEC
   } XFRSTATUS;

typedef struct
   {
   BYTE soh;
   BYTE nBloco;
   BYTE nBloco1;
   BYTE lpBuffer[128];
   BYTE chksum0;
   BYTE chksum1;
   } XMODEMBLK;

typedef struct
   {
   BYTE soh;
   BYTE nBloco;
   BYTE nBloco1;
   } YMODEMBLKSTART;

typedef struct
   {
   BYTE chksum0;
   BYTE chksum1;
   } YMODEMBLKEND;

#define NUL  0x00
#define SOH  0x01
#define STX  0x02
#define ETX  0x03
#define EOT  0x04
#define ENQ  0x05
#define ACK  0x06
#define XON  0x11
#define XOFF 0x13
#define NAK  0x15
#define DLE  0x16
#define CAN  0x18

#define MAX_TEMPO_ACK 10  // tempo em segundos entre um bloco e ACK/NAK

void     _inicrc (void);
unsigned _updcrc (unsigned char c);

void LimpaSerial (int iPorta);
void Pausa (int iPorta, int iDecimos);
void xfrDrawFrame (void);
void xfrDrawFrameDial (void);
void xfrDrawProtocol (PROTOCOLO protocolo);
void xfrDrawFile (char far *lpszArq);
void xfrDrawSize (long lSize);
void xfrDrawTransfer (long lSize);
void xfrDrawErrors (void);
void xfrStartTime (void);
void xfrUpdTime (void);
void xfrRestoreFrame (void);
void xfrStatus (XFRSTATUS);
int  xfrCancelou (int iPorta);
