
typedef unsigned char BYTE;
typedef unsigned int  WORD;
typedef unsigned long ULONG;
typedef long          DWORD;

typedef struct
   {
   BYTE Red;
   BYTE Green;
   BYTE Blue;
   } PCXPAL;

/* Cabealho de arquivo PCX */
typedef struct {
   BYTE   PCXid;         /* PCX id, sempre 0x0A  */
   BYTE   Ver;           /* verso do PCX */
   BYTE   EncMeth;       /* 1 = run lenght */
   BYTE   Bpp;           /* bits por pixel */
   WORD   UpLeftX;       /* coordenada X do canto superior esquerdo */
   WORD   UpLeftY;       /* coordenada Y do canto superior esquerdo */
   WORD   LoRightX;      /* coordenada X do canto inferior direito */
   WORD   LoRightY;      /* coordenada Y do canto inferior direito */
   WORD   DispXRes;      /* resoluo horizontal do display */
   WORD   DispYRes;      /* resoluo vertical do display */
   PCXPAL Palette[16];   /* palheta de cores */
   BYTE   Res;           /* reservado */
   BYTE   NumPlanes;     /* nmero de planos */
   WORD   BytesPerLine;  /* bytes por raster line */
   BYTE   Res2[60];      /* reservados */
   } PCX_HDR;

typedef struct
   {
   BYTE rgbBlue;
   BYTE rgbGreen;
   BYTE rgbRed;
   BYTE rgbReserved;
   } RGBQUAD;

/* Cabealho de arquivo .BMP */
typedef struct {
   char   BMPid[2];        /* Identificao do .BMP = "BM" */
   ULONG  FileSize;        /* Tamanho do Arquivo */
   ULONG  Res;
   ULONG  HdrSize;         /* Tamanho do Cabealho */
   ULONG  Res1;
   ULONG  PixelsH;         /* Pixels na Horizontal */
   ULONG  PixelsV;         /* Pixels na vertical */
   WORD   Planos;          /* Nmero de planos */
   WORD   BitsPerPixel;    /* Bits por Pixel */
   ULONG  Compression;     /* Tipo de Compressao (BI_RGB, BI_RLE8, BI_RLE4) */
   ULONG  SizeImage;       /* Tamanho em bytes da imagem (se nao BI_RGB) */
   ULONG  XPelsPerMeter;   /* resolucao horizontal, pixels por metro */
   ULONG  YPelsPerMeter;   /* resolucao vertical, pixels por metro */
   ULONG  ClrUsed;         /* numero de cores usadas (0=todas as cores) */
   ULONG  ClrImportant;
   } BMP_HDR;

/* Cabecalho de arquivo .TIF

         - Possui uma estrutura TIFF_HDR;
         -  seguido por um nmero varivel de elementos (TIFF_TAG).
           O nmero de elementos  dado por "NoElems", e inicia de 0 (zero).
         - Termina por uma estrutura TIFF_TRAILER (desconhecida)

         Elementos e dados conhecidos:

         IdTag       Valor
         -----       -----
         255         SubFileType
         256         ImageWidth (pixels na horizontal)
         257         ImageLength (pixels na vertical)
         258         BitsPerSample
         259         Compression
                        0x01 - sem compresso
                        0x02 - FAX CCITT  (No suportado)
                        0x05 - packbits (MacIntosh)
         262         Photometric Interpretation
         263         Thresholding
         273         StripOffsets
         277         SamplesPerPixel
         282         xResolution
         283         yResolution
         284         PlanarConfiguration
*/
typedef struct {
   char  TIFid[3];         /* Identificao do .TIF = "II*" */
   BYTE  Res1[5];
   WORD  NoElems;       /* N de elementos que seguem este cabealho */
   } TIFF_HDR;

typedef struct
   {
   WORD  IdTag;
   BYTE  Res1[6];
   WORD  Valor;
   BYTE  Res2[2];
   } TIFF_TAG;

typedef struct
   {
   BYTE  Res[20];
   } TIFF_TRAILER;

